<?php

namespace Drupal\vlsuite_block_cta\Entity\Bundle;

use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\vlsuite_block\Entity\Bundle\VLSuiteBlockBase;
use Drupal\vlsuite_bundle_field\BundleField\VLSuiteBundleFieldCtaTrait;

/**
 * Bundle class for VLSuiteBlockCTA.
 */
class VLSuiteBlockCta extends VLSuiteBlockBase {

  const BUNDLE_KEY = 'vlsuite_cta';

  use VLSuiteBundleFieldCtaTrait {
    bundleFieldDefinitions as bundleFieldDefinitionsCta;
  }

  /**
   * {@inheritdoc}
   */
  public static function bundleFieldDefinitions(EntityTypeInterface $entity_type, $bundle, array $base_field_definitions): array {
    $fields = parent::bundleFieldDefinitions($entity_type, $bundle, $base_field_definitions);

    $fields += self::bundleFieldDefinitionsCta($entity_type, $bundle, $base_field_definitions);

    return $fields;
  }

  /**
   * {@inheritdoc}
   */
  public static function getUtilityClassesDefinitions() {
    $utility_classes_definitions = [];
    $utility_classes_definitions['vlsuite_block:' . self::BUNDLE_KEY] = [
      'admin_title' => t('VLSuite - CTA (block)'),
      'form_element_title' => t('Block'),
    ];
    $utility_classes_definitions['vlsuite_block:' . self::BUNDLE_KEY . ':vlsuite_link'] = [
      'admin_title' => t('VLSuite - CTA: Link (block field)'),
      'form_element_title' => t('Link'),
    ];
    return $utility_classes_definitions;
  }

}
