<?php

namespace Drupal\vlsuite_block_image\Entity\Bundle;

use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\vlsuite_block\Entity\Bundle\VLSuiteBlockBase;
use Drupal\vlsuite_bundle_field\BundleField\VLSuiteBundleFieldImageTrait;

/**
 * Bundle class for VLSuiteBlockImage.
 */
class VLSuiteBlockImage extends VLSuiteBlockBase {

  const BUNDLE_KEY = 'vlsuite_image';

  use VLSuiteBundleFieldImageTrait {
    bundleFieldDefinitions as bundleFieldDefinitionsImage;
  }

  /**
   * {@inheritdoc}
   */
  public static function bundleFieldDefinitions(EntityTypeInterface $entity_type, $bundle, array $base_field_definitions): array {
    $fields = parent::bundleFieldDefinitions($entity_type, $bundle, $base_field_definitions);

    $fields += self::bundleFieldDefinitionsImage($entity_type, $bundle, $base_field_definitions);

    return $fields;
  }

  /**
   * {@inheritdoc}
   */
  public static function getUtilityClassesDefinitions() {
    $utility_classes_definitions = [];
    $utility_classes_definitions['vlsuite_block:' . self::BUNDLE_KEY] = [
      'admin_title' => t('VLSuite - Image (block)'),
      'form_element_title' => t('Block'),
    ];
    $utility_classes_definitions['vlsuite_block:' . self::BUNDLE_KEY . ':vlsuite_image'] = [
      'admin_title' => t('VLSuite - Image: Image (block field)'),
      'form_element_title' => t('Image'),
    ];
    return $utility_classes_definitions;
  }

}
