<?php

namespace Drupal\vlsuite_block\EventSubscriber;

use Drupal\layout_builder\Event\SectionComponentBuildRenderArrayEvent;
use Drupal\layout_builder\LayoutBuilderEvents;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Drupal\vlsuite_utility_classes\VLSuiteUtilityClassesHelper;

/**
 * VLSuiteBlockBuildRenderArray event subscriber.
 */
class VLSuiteBlockBuildRenderArray implements EventSubscriberInterface {

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    return [
      LayoutBuilderEvents::SECTION_COMPONENT_BUILD_RENDER_ARRAY => ['onBuildRender'],
    ];
  }

  /**
   * Add utility classes configuration to block render array.
   *
   * @param \Drupal\layout_builder\Event\SectionComponentBuildRenderArrayEvent $event
   *   The section component render event.
   */
  public function onBuildRender(SectionComponentBuildRenderArrayEvent $event) {
    $build = $event->getBuild();
    if (!empty($build)) {
      $build['#' . VLSuiteUtilityClassesHelper::UTILITY_CLASSES_KEY] = $event->getComponent()->get(VLSuiteUtilityClassesHelper::UTILITY_CLASSES_KEY);
      $event->setBuild($build);
    }
  }

}
